<!--
    Copyright (c) 2021, Texas Instruments Incorporated
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

    *   Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    *   Neither the name of Texas Instruments Incorporated nor the names of
    its contributors may be used to endorse or promote products derived
    from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
    THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
    OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
    EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <title>gc-widget-grid Demo</title>
    <script nomodule src="../../build/gc-components.js"></script>
    <script type="module" src="../../build/gc-components.esm.js"></script>
    <script type="module" src="../../gc-core-databind/lib/CoreDatabind"></script>
    <link rel="stylesheet" type="text/css" href="../../../assets/stylesheets/gc-demo-stylesheet.css">
    <link rel="stylesheet" type="text/css" href="../../../assets/stylesheets/gc-core-stylesheet.css">
    <style>
        body {
            width: 100%;
            height: 100%;
            margin: 0px;
        }

        #grid {
            width: calc(100% - 44px);
            height: calc(100% - 44px);
            position: absolute;
            margin: 0px;
        }

        #editModeLabel {
            position: absolute;
            left: 20px;
            bottom: 0px;
            margin: 0px;
        }

        .end {
            --gc-text-align: end;
        }

        .center {
            --gc-text-align: center;
        }
    </style>
</head>

<body>
    <gc-widget-theme id="theme">
    </gc-widget-theme>

    <div id="demo_container" flex two style="justify-content: start; margin-right: 0px">
        <gc-widget-grid id="grid" virtual>
            <gc-widget-grid-data-column id="select" heading="Select" name="check" format="boolean" class="center" hide-minimize-action ></gc-widget-grid-data-column>
            <gc-widget-grid-tree-column heading="Category\nSub-Category" hide-minimize-action flex one>
                <gc-widget-toolbar-action size="s" icon="content:sort"></gc-widget-toolbar-action>
                <gc-widget-icon appearance="custom" size="s" icon="action:search"></gc-widget-icon>
            </gc-widget-grid-tree-column>
            <gc-widget-grid-data-column id="text" heading="Description" name="text" format="text" class="center" readonly flex one></gc-widget-grid-data-column>
            <gc-widget-grid-data-column id="datum" heading="Datum" name="data" format="hex" precision="4" class="end">
            </gc-widget-grid-data-column>
            <gc-widget-grid-data-column id="selected" heading="Selected" name="selected" format="text" class="center" options="No,Yes" style="--gc-column-width: 100px"></gc-widget-grid-data-column>
        </gc-widget-grid>
        <gc-widget-label id="editModeLabel" label="F2 Edit" hidden></gc-widget-label>
    </div>
    <div id="demo_properties_container" class="no-theme" style="flex: none; padding: 0 10px 0 20px">
        <table>
            <tr>
                <th>
                    <gc-widget-label label="Property"></gc-widget-label>
                </th>
                <th>
                    <gc-widget-label label="Value"></gc-widget-label>
                </th>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="virtual"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-checkbox id="virtual"></gc-widget-checkbox>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="smoothScrolling"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-checkbox id="smoothScrolling"></gc-widget-checkbox>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="selectedRow"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-input id="selectedRow" format="dec"></gc-widget-input>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="selectedPath"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-input id="selectedPath" format="text"></gc-widget-input>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="filterText"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-input id="filterText" format="text" intermediate-changes></gc-widget-input>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="sortByColumn"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-select id="sortByColumn" labels="|Category|Description|Datum|" values="|name|text|data"></gc-widget-select>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="sortDescending"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-checkbox id="sortDescending"></gc-widget-checkbox>
                </td>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="Theme"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-select id="themeSelect" labels="Light,Dark" initial-index="0"></gc-widget-select>
                </td>
            </tr>
        </table>
        <table>
            <tr>
                <th>
                    <gc-widget-label label="Style"></gc-widget-label>
                </th>
                <th>
                    <gc-widget-label label="Value"></gc-widget-label>
                </th>
            </tr>
            <tr>
                <td>
                    <gc-widget-label label="--gc-row-height"></gc-widget-label>
                </td>
                <td>
                    <gc-widget-input id="rowHeight" format="text"></gc-widget-input>
                </td>
            </tr>
        </table>
    </div>

    <script type="module">
        import('../../gc-widget-base/lib/GcWidget').then(({ GcWidget }) => {
            return GcWidget.querySelector('#grid');
        }).then((table) => {
            const smallNumbers = [
                'first', 'second', 'third', 'fourth', 'fifth', 'sixth', 'seventh', 'eighth', 'ninth',
                'tenth', 'eleventh', 'twelfth', 'thirteenth', 'fourteenth', 'fifteenth',
                'sixteenth', 'seventeenth', 'eighteenth', 'nineteenth'];
            const bigNumbers = ['twent', 'thirt', 'fourt', 'fift', 'sixt', 'sevent', 'eight', 'nint'];
            function getNumberAsText(value) {
                if (value < 20) return smallNumbers[value - 1];
                if (value > 99) return 'one hundredth';
                if (value % 10 === 0) return bigNumbers[(value / 10) - 2] + 'ieth';
                return `${bigNumbers[Math.floor(value / 10) - 2]}y ${smallNumbers[(value % 10) - 1]}`;
            }
            function getRowByName(name) {
                const pos = name.indexOf('#');
                return pos > 0 ? +name.substring(pos + 1) : -1;
            }

            table.setDataProvider({
                checkedState: new Array(100).fill(false),
                dataValues: new Array(100).fill(null).map( (_, i) => i),
                rowCount: 100, setValue: function(row, column, value) {
                    if (column === 'check') {
                        this.checkedState[row] = value;
                    } else if (column === 'data') {
                        this.dataValues[row] = value;
                    } else if (column === 'selected') {
                        this.checkedState[row] = value === 'Yes';
                    }
                }, getValue: function(row, column) {
                    if (column === 'check') {
                        return this.checkedState[row];
                    }
                    if (column === 'text') {
                        return `This is the ${getNumberAsText(row + 1)} row.`;
                    }
                    if (column === 'selected') {
                        return this.checkedState[row] ? 'Yes' : 'No';
                    }
                    if (column === 'data') {
                        return this.dataValues[row];
                    }
                    if (column === 'name') {
                        return `This is folder #${row}`;
                    }
                }, isExpandable: function(row) {
                    return true;
                }, getChildDataProvider: function(row) {
                    return {
                        checkedState: new Array(4).fill(true),
                        rowCount: 4,
                        setValue: function (row, column, value) {
                            if (column === 'check') {
                                this.checkedState[row] = value;
                            } else if (column === 'text') {
                            }
                        }, getValue: function (row, column) {
                            if (column === 'check') {
                                return this.checkedState[row];
                            }
                            if (column === 'text') {
                                return `This is the ${getNumberAsText(row + 1)} child.`;
                            }
                            if (column === 'name') {
                                return `This is child folder #${row}`;
                            }
                        },
                        lookupRowByName: getRowByName
                    }
                },
                lookupRowByName: getRowByName
            });
        });
    </script>

</body>

</html>